{   121-  }

unit CalculatorP;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls, Menus, Math, ComCtrls;

type
  TCalculatorForm = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    ZeroButton: TSpeedButton;
    OneButton: TSpeedButton;
    FourButton: TSpeedButton;
    SevenButton: TSpeedButton;
    SignButton: TSpeedButton;
    TwoButton: TSpeedButton;
    FiveButton: TSpeedButton;
    EightButton: TSpeedButton;
    CommaButton: TSpeedButton;
    ThreeButton: TSpeedButton;
    SixButton: TSpeedButton;
    NineButton: TSpeedButton;
    PlusButton: TSpeedButton;
    MinusButton: TSpeedButton;
    MultiplyButton: TSpeedButton;
    DivideButton: TSpeedButton;
    EqualButton: TSpeedButton;
    AdverseButton: TSpeedButton;
    PercentButton: TSpeedButton;
    RootButton: TSpeedButton;
    MemPlusBtn: TSpeedButton;
    SpeedButton22: TSpeedButton;
    MemButton: TSpeedButton;
    MemClearBtn: TSpeedButton;
    ClearAllButton: TSpeedButton;
    ClearButton: TSpeedButton;
    BackButton: TSpeedButton;
    MainMenu: TMainMenu;
    Dzenle1: TMenuItem;
    Kopyala1: TMenuItem;
    Yaptr1: TMenuItem;
    Grnm1: TMenuItem;
    Standart1: TMenuItem;
    Bilimsel1: TMenuItem;
    Yardm1: TMenuItem;
    CalcEdit: TLabel;
    Edit1: TEdit;
    Bevel2: TBevel;
    About1: TMenuItem;
    procedure PlusButtonClick(Sender: TObject);
    procedure ZeroButtonClick(Sender: TObject);
    procedure ClearButtonClick(Sender: TObject);
    procedure ClearAllButtonClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure PercentButtonClick(Sender: TObject);
    procedure RootButtonClick(Sender: TObject);
    procedure CommaButtonClick(Sender: TObject);
    procedure BackButtonClick(Sender: TObject);
    procedure SignButtonClick(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure MemButtonClick(Sender: TObject);
    procedure MemClearBtnClick(Sender: TObject);
    procedure MemPlusBtnClick(Sender: TObject);
    procedure Kopyala1Click(Sender: TObject);
    procedure Yaptr1Click(Sender: TObject);
    procedure Bilimsel1Click(Sender: TObject);
    procedure Edit1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    procedure About1Click(Sender: TObject);
  private
  public
  protected
    function DeleteSubString(substring,InputString: String): String;
    procedure Calculate(Start:Boolean);
    procedure Enter;
  end;
type
  Modes=(Num,Operand,Comma);
var
  CalculatorForm: TCalculatorForm;
  Result,Memory,AdverseNum:Extended;
  Val,Opr,xStr,m:String;
  Mode:Modes;
  Start:Boolean;

implementation

uses SciCalc, About;

{$R *.DFM}

procedure TCalculatorForm.Enter;
begin
  if Mode=Num then
  begin
   if ((CalcEdit.Caption<>'0')) then
   begin
    CalcEdit.Caption:=CalcEdit.Caption+Val
   end
   else
   begin
    CalcEdit.Caption:=Val;
   end;
  end;
  if Mode=Comma then
  begin
   CalcEdit.Caption:=CalcEdit.Caption+Val
  end;
  if Mode=Operand then
  begin
   CalcEdit.Caption:=Val;
  end;
  Start:=False;
end;

procedure TCalculatorForm.Calculate(Start:Boolean);
 var
  i:Extended;
begin
  if Opr='Cube' then
  begin
   Result:=(Sqr(StrToFloat(CalcEdit.Caption)));
  end;
  if Opr='Exp' then
  begin
   Result:=Exp(StrToFloat(CalcEdit.Caption))
  end;
  if Opr='Ln' then
  begin
   Result:=Ln(StrToFloat(CalcEdit.Caption))
  end;
  if Opr='Log' then
  begin
   Result:=Log10(StrToFloat(CalcEdit.Caption))
  end;
  if Opr='Factor' then
  begin
   Result:=1;
   i:=StrToFloat(CalcEdit.Caption);
  while i>0 do
  begin
   Result:=Result*i;
   i:=i-1;
  end;
  end;
  if Opr='Tan' then
  begin
   Result:=Tan(StrToFloat(CalcEdit.Caption)*3.14159265359/180)
  end;
  if Opr='Sin' then
  begin
   Result:=Sin(StrToFloat(CalcEdit.Caption)*3.14159265359/180)
  end;
  if Opr='Cos' then
  begin
   Result:=Cos(StrToFloat(CalcEdit.Caption)*3.14159265359/180)
  end;
  if Opr='Cube' then
  begin
   Result:=Sqr(StrToFloat(CalcEdit.Caption))*StrToFloat(CalcEdit.Caption)
  end;
  if Opr='Square' then
  begin
   Result:=Sqr(StrToFloat(CalcEdit.Caption));
  end;
  if Opr='Num' then
  begin
   Result:=Result+StrToFloat(CalcEdit.Caption);
  end;
  if Opr='Plus' then
  begin
   Result:=Result+StrToFloat(CalcEdit.Caption);
  end;
  if Opr='Minus' then
  begin
   Result:=Result-StrToFloat(CalcEdit.Caption);
  end;
  if Opr='Multiply' then
  begin
   Result:=Result*StrToFloat(CalcEdit.Caption);
  end;
  if Opr='Divide' then
  begin
   if Start=True then
   Result:=StrToFloat(CalcEdit.Caption)
   else
   begin
   try
    Result:=Result/StrToFloat(CalcEdit.Caption);
   except on EZeroDivide do
   begin
    Result:=0;
     ShowMessage('  !');
     Beep;
   end;
  end;
  end;
  end;
  if Opr='Adverse' then
  begin
   if Start=True then
    Result:=StrToFloat(CalcEdit.Caption)
   else
   begin
   try
    Result:=1/StrToFloat(CalcEdit.Caption);
   except on EZeroDivide do
   begin
    Result:=0;
    ShowMessage('  !');
    Beep;
   end;
   end;
   end;
   end;
   if Opr='Root' then
   begin
    Result:=SQRT(StrToFloat(CalcEdit.Caption));
   end;
   if Opr='Equal' then
    Result:=StrToFloat(CalcEdit.Caption);
   if Opr='xUPy' then
   begin
    Result:=exp((StrToFloat(CalcEdit.Caption))*Ln(Result));
    end;
   CalcEdit.Caption:=FloatToStr(Result);
end;

function TCalculatorForm.DeleteSubString(Substring,InputString: string): string;
 var
  CharPos,i:Byte;
  tstr:string;
begin
  Result:=InputString;
  i:=Length(SubString);
  tstr:=UpperCase(SubString);
  while True do
  begin
    CharPos:=Pos(tstr,UpperCase(InputString));
    if not (CharPos = 0) then
      Delete(InputString,CharPos,i)
    else
      Break;
  end;
  Result := InputString;
end;

procedure TCalculatorForm.PlusButtonClick(Sender: TObject);
begin
   xStr:=DeleteSubString('Button',((Sender as TSpeedButton).Name));
   if ((Start=False)) //and (Mode<>Operand))
    then
     begin
      if Mode<>Operand then
       Calculate(False);
      Mode:=Operand;
      Opr:=xStr;
     end
    else
     Beep;
end;

procedure TCalculatorForm.RootButtonClick(Sender: TObject);
begin
  xStr:=DeleteSubString('Button',((Sender as TSpeedButton).Name));
  if Start=False then
  begin
   Mode:=Operand;
   Opr:=xStr;
   Calculate(False);
  end;
  Mode:=Num;
  Opr:='Equal';
end;

procedure TCalculatorForm.ClearButtonClick(Sender: TObject);
begin
   Mode:=Num;
   Result:=0;
   Opr:='Num';
   Start:=True;
   CalcEdit.Caption:='0';
end;

procedure TCalculatorForm.ClearAllButtonClick(Sender: TObject);
begin
  ClearButtonClick(self);
  Memory:=0;
end;

procedure TCalculatorForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   Result:=0;
   Mode:=Num;
   Opr:='Num';
  CalculatorForm:=nil;
end;

procedure TCalculatorForm.FormCreate(Sender: TObject);
begin
  Mode:=Num;
  Opr:='Num';
  Start:=True;
  Memory:=0;
  AdverseNum:=0;
  if Caption='' then
   begin
    Standart1.Enabled:=True;
   end
  else
end;

procedure TCalculatorForm.ZeroButtonClick(Sender: TObject);
begin
  Val:=(Sender as TSPeedButton).Caption;
  Enter;
  Mode:=Num;
end;

procedure TCalculatorForm.PercentButtonClick(Sender: TObject);
begin
  if Start=True then
   Beep
  else
   begin
    Calculate(False);
    Mode:=Operand;
    Opr:='Percent';
    Result:=Result/100;
    CalcEdit.Caption:=FloatToStr(Result);
   end;
end;

procedure TCalculatorForm.CommaButtonClick(Sender: TObject);
begin
   if Pos(',',CalcEdit.Caption)=0 then
    begin
     Mode:=Comma;
     Val:=',';
     Enter;
    end
   else
    Beep;
end;

procedure TCalculatorForm.BackButtonClick(Sender: TObject);
begin
   xStr:=CalcEdit.Caption;
   if Length(xStr)>1 then
    Delete(xStr,Length(xStr),1)
   else
    begin
     xStr:='0';
     Beep;
    end;
   CalcEdit.Caption:=xStr;
end;

procedure TCalculatorForm.SignButtonClick(Sender: TObject);
begin
   xStr:=CalcEdit.Caption;
   if CalcEdit.Caption='0' then
    Beep;
   if (Pos('-',CalcEdit.Caption)=0) then
    begin
     Insert('-',xStr,1);
     CalcEdit.Caption:=xStr;
    end
   else
    Delete(xStr,1,1);
    CalcEdit.Caption:=xStr;
end;

procedure TCalculatorForm.SpeedButton1Click(Sender: TObject);
begin
   xStr:=CalcEdit.Caption;
   Delete(xStr,1,1);
   CalcEdit.Caption:=xStr;
end;

procedure TCalculatorForm.MemButtonClick(Sender: TObject);
begin
   Memory:=Result;
   Start:=False;
end;

procedure TCalculatorForm.MemClearBtnClick(Sender: TObject);
begin
   Memory:=0;
   Start:=False;
end;

procedure TCalculatorForm.MemPlusBtnClick(Sender: TObject);
begin
   Memory:=Memory+StrToFloat(CalcEdit.Caption);
   CalcEdit.Caption:=FloatToStr(Memory);
   Start:=False;
   Mode:=Operand;
end;

procedure TCalculatorForm.Kopyala1Click(Sender: TObject);
begin
  Edit1.Text:=CalcEdit.Caption;
  Edit1.SelectAll;
  Edit1.CopyToClipboard;
end;

procedure TCalculatorForm.Yaptr1Click(Sender: TObject);
begin
  Edit1.PasteFromClipboard;
  CalcEdit.Caption:=Edit1.Text;
end;

procedure TCalculatorForm.Bilimsel1Click(Sender: TObject);
begin
  if not Assigned(SciCalcForm) then
  begin
   SciCalcForm:=TSciCalcForm.Create(self);
  with SciCalcForm do
   begin
    Left:=CalculatorForm.Left;
    Top:=CalculatorForm.Top;
    Show;
   end;
  CalculatorForm.Visible:=False;
  end;
end;

procedure TCalculatorForm.Edit1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  case key of
   48,96:Sender:=ZeroButton;
   49,97:Sender:=OneButton;
   50,98:Sender:=TwoButton;
   51,99:Sender:=ThreeButton;
   52,100:Sender:=FourButton;
   53,101:Sender:=FiveButton;
   54,102:Sender:=SixButton;
   55,103:Sender:=SevenButton;
   56,104:Sender:=EightButton;
   57,105:Sender:=NineButton;
  end;

  if key in [48,49,50,51,52,53,54,55,56,57,96,97,98,99,100,101,102,103,104,105] then
  begin
   Val:=(Sender as TSPeedButton).Caption;
   Enter;
   Mode:=Num;
  end;

  case key of
  106:Sender:=MultiplyButton;
  107:Sender:=PlusButton;
  109:Sender:=MinusButton;
  111:Sender:=DivideButton;
   13:Sender:=EqualButton;
  end;

  if key in [106,107,109,111,13] then
  begin
  xStr:=DeleteSubString('Button',((Sender as TSpeedButton).Name));
   if Start=False
    then
     begin
      Mode:=Operand;
      Calculate(False);
      Opr:=xStr;
     end
    else
     Beep;
  end;

  case key of
  110:
  begin
   if Pos(',',CalcEdit.Caption)=0 then
    begin
     Mode:=Comma;
     Val:=',';
     Enter;
    end
   else
    Beep;
  end;
  end;
end;

procedure TCalculatorForm.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
  Case Key Of
    '0': Exit; '1': Exit; '2': Exit; '3': Exit; '4' : Exit; '5': Exit; '6': Exit;
    '7': Exit; '8': Exit; '9': Exit; #44: Exit; #46: Exit; #8: Exit; #9: Exit;
    #13: Exit;
  end;
    Key:=#0;
end;

procedure TCalculatorForm.About1Click(Sender: TObject);
begin
  AboutBox.ShowModal;
end;

end.
