unit SciCalc;
interface
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  CalculatorP, Buttons, StdCtrls, ExtCtrls, Menus;
type
  TSciCalcForm = class(TCalculatorForm)
    CosButton: TSpeedButton;
    SinButton: TSpeedButton;
    CubeButton: TSpeedButton;
    xUPyButton: TSpeedButton;
    ExpButton: TSpeedButton;
    FactorButton: TSpeedButton;
    LogButton: TSpeedButton;
    LnButton: TSpeedButton;
    TanButton: TSpeedButton;
    SquareButton: TSpeedButton;
    PiBtn: TSpeedButton;
    Bevel3: TBevel;
    procedure Standart1Click(Sender: TObject);
    procedure PiBtnClick(Sender: TObject);
    procedure AClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  SciCalcForm: TSciCalcForm;

implementation

{$R *.DFM}

procedure TSciCalcForm.Standart1Click(Sender: TObject);
begin
   with CalculatorForm do
    begin
     Left:=SciCalcForm.Left;
     Top:=SciCalcForm.Top;
     Show;
    end;
  SciCalcForm.Close;
//Bitmap.LoadFromFile(1.bmp);
//

end;

procedure TSciCalcForm.PiBtnClick(Sender: TObject);
begin
  CalcEdit.Caption:=FloatToStr(Pi);
end;

procedure TSciCalcForm.AClick(Sender: TObject);
begin
   Val:=(Sender as TSpeedButton).Caption;
   Enter;
   Mode:=Num;
end;

procedure TSciCalcForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  SciCalcForm:=nil;
  CalculatorForm.Enabled:=True;
end;

end.
